package org.coderu.core.api;

import java.util.Collection;

public interface WrongDependencyExplorer {

    public Collection<ClazzDependency> calculate( // NO_UCD
        Collection<CompileUnit> classpath, Collection<Packagge> packagges);

    public Collection<ClazzDependency> calculate(
        Collection<CompileUnit> classpath, Collection<Packagge> packagges,Collection<Packagge> excluded);

    public Collection<ClazzDependency> calculate(
        Collection<CompileUnit> classpath, Collection<Packagge> packagges, Depth depth);

    public Collection<ClazzDependency> calculate(
        Collection<CompileUnit> classpath, 
        Collection<Packagge> components,
        Collection<Packagge> excluded,
        Depth depth);

    public Collection<ClazzDependency> calculate(
        Collection<CompileUnit> classpath, 
        Collection<Packagge> packagges,
        Collection<Packagge> excluded, 
        Depth depth,
        DependencyOnSameLevelAllowed dependencyOnSameLevelAllowed);

}
