package org.coderu.core.impl.common.types;

import java.util.Collection;

import org.coderu.common.utils.types.AbstractTriple;
import org.coderu.core.api.Packagge;

import com.google.common.base.Function;


public final class PackageWithClasses 
extends AbstractTriple<Packagge, Collection<ClassDependencies>, Collection<Packagge>> {

    public static final Function<PackageWithClasses,Packagge> TO_PACKAGE = 
        new Function<PackageWithClasses, Packagge>() {
        
        public Packagge apply(PackageWithClasses o) {
        
            return o.getFirst();
        }
    };
    
    public PackageWithClasses(
        final Packagge name, 
        final Collection<ClassDependencies> classes, 
        final Collection<Packagge> dependsOn) {

        super(name, classes, dependsOn);
    }

    
}
